import os
import h5py
import numpy as np
import pandas as pd
import datetime


data_file_path_pemsm = "./data/PeMS-M/V_228.csv"


strTime = '2012-05-01 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
index = []
temp = startTime
# 第一周
for i in range(1, 4*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

# 第二周
strTime = '2012-05-07 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

# 第三周
strTime = '2012-05-14 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

#
# 第四周
strTime = '2012-05-21 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
#
# 第五周
strTime = '2012-05-28 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
#
# 第六周
strTime = '2012-06-04 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第七周
strTime = '2012-06-11 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第八周
strTime = '2012-06-18 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第九周
strTime = '2012-06-25 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
print(index)
print(len(index))
date_index = pd.to_datetime(index)
data_seq = pd.read_csv(data_file_path_pemsm, header=None)
print(data_seq)
df_pemsm = data_seq.set_index(date_index)
print(df_pemsm)
print(df_pemsm.shape)
df_pemsm.to_hdf("./data/h5_format/pemsm_data.h5", key='df_pemsm')
